#ifndef __kinematics_H_INCLUDED__                                      
#define __kinematics_H_INCLUDED__




	void test_out(float array[], int limit);
//	void test_out111();
    void Cal_print();

    const float m_e    = 0.511 ;
    const float m_pi   = 139.57 ;
    const float m_pi_g = m_pi/1000. ;
    const float m_p    = 938.27 ;
    const float m_p_g  = m_p/1000. ;
    const float PI     = 3.1415926;

	// Beam energy in MeV
	//const int beam_energy[6] = {6600, 7400, 7900, 8800, 9900, 10900};
	//const int beam_energy[7] = {6600, 7400, 7900, 8800, 9200, 9900, 10900};
	const int beam_energy[4] = {3778, 4210, 4702, 5248};
	//const int beam_energy[3] = {2800, 3700, 4200};


	// Incoming electron beam kinetic energy, total energy and momentum
	float t_in, t_in_g, e_in, e_in_g, p_in, p_inx, p_inz;

	float e_scat, e_scat_g, t_scat, t_scat_g, p_scat, p_scatx, p_scatz;
	

	float angle, theta_angle;

	float epsilon;



	float p_gamma_g, p_gamma, p_gammax, p_gammay, p_gammaz, p_gamma_temp;

	float theta_gamma;

	float phix;
	
	float ithpq_lab, thpq_lab, thp_lab, thp_cm, thmq_lab;

	float a, b, c;

	float cos_thp;

	float p_proton_lab;

	float theta_meson_cm;
	
	float tan_theta_messon;

	float p_meson_lab, p_meson_lab_g;

	float e_meson;

	float t, t_g, u, u_g;

	float p_cm, e_meson_cm, e_proton_cm, e_proton;

	float p_px, p_py, p_pz, p_ptemp;

	float thp, vertp;

	float x, z;


// //	float *Q1p6_low_eps[3];
// //	float *Q1p6_high_eps[3];
// 
// //	float *Q2p45_low_eps[3];
// //	float *Q2p45_high_eps[3];
// 
// 	float *Q1p6_low_eps;
// 	float *Q1p6_high_eps;
// 
// 	float *Q2p45_low_eps;
// 	float *Q2p45_high_eps;
 



	float Rad_to_Deg(float radian) {return radian*180/PI;} 
	float Deg_to_Rad(float degree) {return degree*PI/180;}

	bool change_beam_e;



	float m_meson_g, q_2_g, W_g;
	float m_meson, q_2, W;

	float nu_g, nu;

	float theqp_Q1p6_low_eps[]   = {-9.534, -10.5, -12.54};
	float theqp_Q1p6_high_eps[]  = {-13.29, -10.55, -16.29};

	float theqp_Q2p45_low_eps[]  = {-9.19,  -10.54, -12.2};
	float theqp_Q2p45_high_eps[] = {-13.61, -10.61, -16.61};
	float beta_cm, gamma_cm;





#endif
